<template>
  <div>
    <div>
<CModal
      title="Modal title"
      size="sm"
      :show.sync="smallModal">
      {{ SuccessMsg }}

</CModal>

<CCardBody>
     <h5>Customer Type Master</h5>
   
    <CDataTable
      :items="items"
      :fields="fields"
      table-filter
      items-per-page-select
        :items-per-page="15"
      pagination
      hover
      striped
      border
      sorter
     >
 
<!--Adding Customs buttons to each row -->
    <template #show_details="{item}" >
      <CButton size="sm" color="info" class="ml-1"  @click="ShowUpdateModal=true; SelectCustomerType(item)"> Update </CButton>
      <CButton size="sm" color="danger" class="ml-1" @click="ShowDeleteModal=true; SelectCustomerType(item)" >Delete</CButton>
      <CButton size="sm" color="dark" class="ml-1" @click="ShowDetailsModal=true; SelectCustomerType(item)"> Details </CButton>
    </template>

    </CDataTable>
      <CButton size="sm" color="info" class="" @click="ShowAddModal=true"> Add New Customer Type</CButton>
  </CCardBody>

 </div>
<div id="overlay" v-if="ShowAddModal">
<div class="modal-dialog">

<div class="modal-content">
  <div class="modal-header">

    <h5 class="modal-title">Add New Customer Type</h5>
    <button type="button" class="close"  @click="ShowAddModal=false">
      <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body p-7">
<form action="#" method="POST">



<!-- 
<div class="form-group">
<input type="text" name="CustomerType_Id" class="form-control form-control-lg" placeholder="CustomerType Id" v-model="newCustomerType.CustomerType_Id">
</div> -->

<div class="form-group">
   <label for="Customer_Type_Name">Customer Type Name</label>
<input type="text" name="Customer_Type_Name" class="form-control form-control-lg" placeholder="" v-model="newCustomerType.customer_Type_Name">
</div>

<!-- <div class="form-group">
<input type="text" name="Customer_Type_Status" class="form-control form-control-lg" placeholder="Customer Type Status" v-model="newCustomerType.customer_Type_Status">
</div> -->


<div class="form-group">
<CButton size="sm" color="info" class=""  @click="ShowAddModal=false;addCustomerType();" >Add CustomerType </CButton>
</div>

</form>
 </div>
</div>
</div>
 </div>

 

<!-- Show Details Modal -->
<div id="overlay" v-if="ShowDetailsModal">
<div class="modal-dialog">

<div class="modal-content">
  <div class="modal-header">
    <h5 class="modal-title">Customer Type Details</h5>
    <button type="button" class="close"  @click="ShowDetailsModal=false">
    <span aria-hidden="true">&times;</span>
    </button>
  </div>
<div class="modal-body p-4">

<form action="#" method="POST">
<div class="form-group">
   <label for="customer_Type_Id">Type Id</label>
<input type="text" label ="Id" name="customer_Type_Id" readonly class="form-control form-control-lg" placeholder= "Customer Type Id" v-model="CurrentCustomerType.customer_Type_Id">
</div>

<div class="form-group">
   <label for="customer_Type_Name">Customer Type </label>
<input type="text" name="customer_Type_Name" readonly class="form-control form-control-lg" placeholder="Customer Type Name" v-model="CurrentCustomerType.customer_Type_Name">
</div>

<div class="form-group">
   <label for="customer_Type_Status"> Type Status</label>
<input type="text" name="customer_Type_Status" readonly class="form-control form-control-lg" placeholder="Customer Type Status" v-model="CurrentCustomerType.customer_Type_Status">
</div>


<div class="form-group">
<button class="btn btn-info btn-block btn-lg"  @click="ShowDetailsModal=false;" > Close </button>
</div>
</form>

</div>
</div>
</div>
</div>


  

<!-- Show Update Modal -->
<div id="overlay" v-if="ShowUpdateModal">
<div class="modal-dialog">

<div class="modal-content">
  <div class="modal-header">
    <h5 class="modal-title">Update Customer Type</h5>
    <button type="button" class="close"  @click="ShowUpdateModal=false">
    <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body p-4">
<form action="#" method="POST">
<div class="form-group">
   <label for="customer_Type_Id"> Type Id</label>
<input type="text" label ="Id" name="customer_Type_Id" readonly class="form-control form-control-lg" placeholder= "Customer Type Id" v-model="CurrentCustomerType.customer_Type_Id">
</div>

<div class="form-group">
   <label for="customer_Type_Name"> Type Name</label>
<input type="text" name="customer_Type_Name" class="form-control form-control-lg" placeholder="Customer Type Name" v-model="CurrentCustomerType.customer_Type_Name">
</div>




<div class="form-group">
<button class="btn btn-info btn-block btn-lg"  @click="ShowUpdateModal=false;UpdateCustomerType();" > Update CustomerType </button>
</div>
</form>

</div>
</div>
</div>
</div>


<!-- Delete Modal -->
<div id="overlay" v-if="ShowDeleteModal">
<div class="modal-dialog">

<div class="modal-content">
  <div class="modal-header">

    <h5 class="modal-title">Delete Customer Type</h5>
    <button type="button" class="close"  @click="ShowDeleteModal=false">
    <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body p-4">
<h4 class="text-danger"> Are you sure want to delete the CustomerType ? </h4>
<h5> You are deleting {{ this.CurrentCustomerType.customer_Type_Id +' || '+ this.CurrentCustomerType.customer_Type_Name }}</h5>
<hr>
<button class="btn btn-danger btn-lg" @click="ShowDeleteModal=false; deleteCustomerType();getAllCustomerTypeDetails();"> Yes </button>
&nbsp;&nbsp;&nbsp;&nbsp;  
<button class="btn btn-success btn-lg" @click="ShowDeleteModal=false"> No </button>
</div>
</div>
</div>
</div>
</div>
</template>

<script>
const apiurl =  'FGS_FIFO_CustomerType_Master/'
 const items = [
  { key: 'customer_Type_Id',  },
  { key: 'customer_Type_Name',  },
 // { key: 'customer_Type_Status', _style:'min-width:50px;' },
 
 ]    
import Vue from 'vue'
import axios from 'axios'
import VUEAxios from 'vue-axios'
Vue.use(VUEAxios,axios)

export default {
  data ()
  {
     return {
     items: items.map((item,) => { return {...item,}}),
     fields: [
              { key: 'customer_Type_Id' , label: 'Customer Type Id',},
              { key: 'customer_Type_Name', label: 'Customer Type Name', },
             // { key: 'customer_Type_Status', label: 'Customer Type Status', _classes: 'font-weight-bold' },
              { key: 'show_details',  label: '',  _style: 'width:30%', }          
      ],
  details: [],
  errMsg:"",
  SuccessMsg:"",
  ShowAddModal:"",
  ShowDeleteModal:"",
  CurrentCustomerType:"",
  ShowUpdateModal:"",
  ShowDetailsModal:"",
  smallModal: false,
  newCustomerType: {customer_Type_Id:0,customer_Type_Name:"", customer_Type_Status : 1}, }
  },
 


  mounted()
  {
  
   this.getAllCustomerTypeDetails();
  },

  methods:
  {
   getAllCustomerTypeDetails: function()
   {
   Vue.axios.get(this.$url + apiurl)
    .then((response)=>{
    if(response.data.error)
       {
         this.errMsg=response.data.message;
       }
    else
       {
        this.items =response.data.filter(x => x.customer_Type_Status == 1)
        
       }
    });
   },

   
  addCustomerType()
  {
    if(this.items.find(x => x.customer_Type_Name == this.newCustomerType.customer_Type_Name && x.customer_Type_Status == this.newCustomerType.customer_Type_Status))
    {
     this.SuccessMsg= "Material Customer Type Name " + this.newCustomerType.customer_Type_Name +" already exist. Please try another Name";
     this.smallModal = true;

    }
    else
    {
   Vue.axios.post(this.$url + apiurl,this.newCustomerType).then((response)=>{
       if(response.data.error)
       {
          alert('Data Error')
       }
       else
       {
          this.SuccessMsg ="Record added Successfully.."
       // this.smallModal = true;
        this.getAllCustomerTypeDetails();
        location.reload();
       }
    })
    }
   },

  UpdateCustomerType()
  {
   
    Vue.axios.put(this.$url + apiurl+this.CurrentCustomerType.customer_Type_Id,this.CurrentCustomerType,).then((response)=>{
       if(response.data.error)
       {
          alert('Data Error')
       }
       else
       {
         this.SuccessMsg ="Records Updated Successfully.."
         this.getAllCustomerTypeDetails();
       }
    })
   },

  deleteCustomerType()
    {
    
      var customer_Type_Id = this.CurrentCustomerType.customer_Type_Id;
        axios({   method: 'delete',
        url: this.$url + apiurl+ customer_Type_Id
    });   
        this.SuccessMsg="CustomerType Status of "+ customer_Type_Id +" Changed to Inactive Succesfully"
         this.getAllCustomerTypeDetails();
    },
      
  SelectCustomerType(CustomerType)
    {
     this.CurrentCustomerType=CustomerType;
    },
    
  
  },

}
</script>

<style scoped>
#overlay{
  position:absolute;
  top:100px;
  bottom:0;
  left:0;
  right:0;
  background:rgba(0,0,0,0.6);
}
</style>